/*
 * Copyright (c) 1992, 1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Utah $Hdr: autoconf.c 1.8 94/12/07$
 */

/*
 *	Autoconfigure devices
 */

#ifdef MACH_KERNEL
#include <sys/types.h>
#endif

#ifndef BOOTDEV
#define BOOTDEV	"sd5a"
#endif
#ifndef DUMPDEV
#define DUMPDEV	"sd5b"
#endif

autoconf()
{
	ioconf();
	cninit();
#ifdef  KGDB
#ifdef	KGDB_LAN
	kgdb_mux_init();
#else
{
        extern int kgdb_dev, kgdb_rate;

        if (kgdb_dev != -1) {
                dcainit(minor(kgdb_dev), kgdb_rate);
                kgdb_mux_init();
        }
}
#endif
#endif
}

static char boot_device[10] = BOOTDEV;
static char dump_device[10] = DUMPDEV;
char *root_name = boot_device;
char *dump_name = dump_device;

get_root_device()
{
	printf("root on %s\n", root_name);
}
