/*	$CHeader: gdb_packet.h 1.3 93/04/26 17:27:18 $ */

/*
 * Mach Operating System
 * Copyright (c) 1993, CONVEX Computer Corporation.
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CONVEX ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION,
 * AND DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 * RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 */

/*
 * This file defines the layout of requests and responses for the remote
 * microkernel and task debuggers.  In both cases, requests come only from
 * the remote debugger.  Responses are sent back only when a request is
 * received.
 */

struct gdb_request {
	unsigned int	xid;
	unsigned int	type;
	unsigned int	task_id;
	unsigned int	thread_id;
	unsigned int	request;
	unsigned int	address;
	unsigned int	size;
	char		data[512];
};

typedef struct gdb_request *gdb_request_t;

#define RESPONSE_DATA_SIZE 1024

struct gdb_response {
	unsigned int	xid;
	unsigned int	type;
	unsigned int	task_id;
	unsigned int	thread_id;
	unsigned int	return_code;
	unsigned int	size;
	char		data[RESPONSE_DATA_SIZE];
};

typedef struct gdb_response *gdb_response_t;
