/*
 *  (c) Copyright 1988 HEWLETT-PACKARD COMPANY
 *
 *  To anyone who acknowledges that this file is provided "AS IS"
 *  without any express or implied warranty:
 *      permission to use, copy, modify, and distribute this file
 *  for any purpose is hereby granted without fee, provided that
 *  the above copyright notice and this notice appears in all
 *  copies, and that the name of Hewlett-Packard Company not be
 *  used in advertising or publicity pertaining to distribution
 *  of the software without specific, written prior permission.
 *  Hewlett-Packard Company makes no representations about the
 *  suitability of this software for any purpose.
 */

/*
 * Copyright (c) 1990,1991,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * THE UNIVERSITY OF UTAH AND CSL PROVIDE THIS SOFTWARE IN ITS "AS IS"
 * CONDITION, AND DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM ITS USE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: movc.s 1.26 94/12/14$
 */

#include <machine/asm.h>
#include <machine/cpu.h>
#include <assym.s>
#include <machine/psl.h>
#include <mach/machine/vm_param.h>
#include <machine/pmap.h>

	.space	$PRIVATE$
	.subspa	$DATA$

	.import cur_pcb,data
	.import dcache_line_mask,data

	.space	$TEXT$
	.subspa $CODE$


	.code
	.export memcpy,entry
memcpy
	copy	arg0,arg3
	copy	arg1,arg0
	copy	arg3,arg1
	/* And fall into....  */
/*
 * void 
 * bcopy(src, dst, count)
 *	vm_offset_t	src;
 *	vm_offset_t	dst;
 *	int		count;
 */

	.export	bcopy,entry
	.proc
	.callinfo 
bcopy
	.entry
        comb,>=,n r0,arg2,$bcopy_exit

	/*
	 * See if the source and destination are word aligned and if the count
	 * is an integer number of words. If so then we can use an optimized 
	 * routine. If not then branch to bcopy_checkalign and see what we can
	 * do there.
	 */

        or	arg0,arg1,t1
        or	t1,arg2,t2
        extru,= t2,31,2,r0
        b,n     $bcopy_checkalign

        addib,<,n -16,arg2,$bcopy_movewords

	/*
	 * We can move the data in 4 word moves. We'll use 4 registers to 
	 * avoid interlock and pipeline stalls.
	 */

$bcopy_loop16

        ldwm	16(arg0),t1
        ldw	-12(arg0),t2
        ldw     -8(arg0),t3
        ldw     -4(arg0),t4
        stwm    t1,16(arg1)
        stw     t2,-12(arg1)
        stw     t3,-8(arg1)
        addib,>= -16,arg2,$bcopy_loop16
        stw     t4,-4(arg1)


	/*
	 * We have already decremented the count by 16, add 12 to it and then 
	 * we can test if there is at least 1 word left to move.
	 */

$bcopy_movewords
        addib,<,n 12,arg2,$bcopy_exit

	/*
	 * Clean up any remaining words that were not moved in the 16 byte
	 * moves
	 */

$bcopy_loop4
        ldwm	4(arg0),t1
        addib,>= -4,arg2,$bcopy_loop4
        stwm    t1,4(arg1)

	bv,n 	0(r2)


$bcopy_checkalign

	/*
	 * The source or destination is not word aligned or the count is not 
	 * an integral number of words. If we are dealing with less than 16 
	 * bytes then just do it byte by byte. Otherwise, see if the data has 
	 * the same basic alignment. We will add in the byte offset to size to
	 * keep track of what we have to move even though the stbys instruction
	 * won't physically move it. 
	 */

        comib,>= 15,arg2,$bcopy_byte
        extru   arg0,31,2,t1
        extru   arg1,31,2,t2
        add     arg2,t2,arg2
        comb,<> t2,t1,$bcopy_unaligned
        dep     0,31,2,arg0

	/*
	 * the source and destination have the same basic alignment. We will 
	 * move the data in blocks of 16 bytes as long as we can and then 
	 * we'll go to the 4 byte moves.
	 */

        addib,<,n -16,arg2,$bcopy_aligned2

$bcopy_loop_aligned4
        ldwm	16(arg0),t1
        ldw     -12(arg0),t2
        ldw     -8(arg0),t3
        ldw     -4(arg0),t4
        stbys,b,m t1,4(arg1)
        stwm    t2,4(arg1)
        stwm    t3,4(arg1)
        addib,>= -16,arg2,$bcopy_loop_aligned4
        stwm    t4,4(arg1)

	/*
	 * see if there is anything left that needs to be moved in a word move.
	 * Since the count was decremented by 16, add 12 to test if there are 
	 * any full word moves left to do.
	 */

$bcopy_aligned2
        addib,<,n 12,arg2,$bcopy_cleanup

$bcopy_loop_aligned2
        ldws,ma	4(arg0),t1
        addib,>= -4,arg2,$bcopy_loop_aligned2
        stbys,b,m t1,4(arg1)

	/*
	 * move the last bytes that may be unaligned on a word boundary
	 */

$bcopy_cleanup
         addib,=,n 4,arg2,$bcopy_exit
         ldws	0(arg0),t1
         add    arg1,arg2,arg1
	 bv	0(r2)
         stbys,e t1,0(arg1)

	/*
	 * The source and destination are not alligned on the same boundary 
	 * types. We will have to shift the data around. Figure out the shift 
	 * amount and load it into cr11.
	 */

$bcopy_unaligned
        sub,>=	t2,t1,t3
        ldwm    4(arg0),t1
        zdep    t3,28,29,t4
        mtctl   t4,11

	/*
	 * see if we can do some of this work in blocks of 16 bytes
	 */

        addib,<,n -16,arg2,$bcopy_unaligned_words

$bcopy_unaligned4
        ldwm	16(arg0),t2
	ldw	-12(arg0),t3
	ldw	-8(arg0),t4
	ldw	-4(arg0),r1
        vshd	t1,t2,r28
        stbys,b,m r28,4(arg1)
        vshd	t2,t3,r28
        stwm	r28,4(arg1)
        vshd	t3,t4,r28
        stwm	r28,4(arg1)
        vshd	t4,r1,r28
        stwm   	r28,4(arg1)
        addib,>= -16,arg2,$bcopy_unaligned4
	copy	r1,t1

	/*
	 * see if there is a full word that we can transfer
	 */

$bcopy_unaligned_words
        addib,<,n 12,arg2,$bcopy_unaligned_cleanup1

$bcopy_unaligned_loop
        ldwm	4(arg0),t2
        vshd    t1,t2,t3
        addib,< -4,arg2,$bcopy_unaligned_cleanup2
        stbys,b,m t3,4(arg1)

        ldwm	4(arg0),t1
        vshd    t2,t1,t3
        addib,>= -4,arg2,$bcopy_unaligned_loop
        stbys,b,m t3,4(arg1)

$bcopy_unaligned_cleanup1
	copy	t1,t2

$bcopy_unaligned_cleanup2
	addib,<=,n 4,arg2,$bcopy_exit
        add	arg1,arg2,arg1
	mfctl	sar,t3
	extru	t3,28,2,t3
	sub,<=	arg2,t3,r0
        ldwm    4(arg0),t1
        vshd    t2,t1,t3
        bv      0(r2)
        stbys,e t3,0(arg1)

	/*
	 * move data one byte at a time
	 */

$bcopy_byte
        comb,>=,n r0,arg2,$bcopy_exit

$bcopy_loop_byte
        ldbs,ma	1(arg0),t1
        addib,> -1,arg2,$bcopy_loop_byte
        stbs,ma t1,1(arg1) 

$bcopy_exit
	bv,n	0(r2)
	.exit
	.procend


/*
 * void 
 * bzero(dst, count)
 *	vm_offset_t	dst;
 *	int		count;
 *
 * void
 * blkclr(dst, count)
 *	vm_offset_t	dst;
 *	int		count;
 */

	.export	bzero,entry
	.export	blkclr,entry
	.proc
	.callinfo 
bzero
blkclr
	.entry
        comb,>=,n r0,arg1,$bzero_exit

	/*
	 * If we need to clear less than a word do it a byte at a time
	 */

	comib,>,n 4,arg1,$bzero_bytes

	/*
	 * Since we are only clearing memory the alignment restrictions 
	 * are simplified. Figure out how many "extra" bytes we need to
	 * store with stbys.
	 */

        extru   arg0,31,2,t2
        add     arg1,t2,arg1

	/*
	 * We will zero the destination in blocks of 16 bytes as long as we 
	 * can and then we'll go to the 4 byte moves.
	 */

        addib,<,n -16,arg1,$bzero_word

$bzero_loop_16
        stbys,b,m r0,4(arg0)
        stwm    r0,4(arg0)
        stwm    r0,4(arg0)
        addib,>= -16,arg1,$bzero_loop_16
        stwm    r0,4(arg0)

	/*
	 * see if there is anything left that needs to be zeroed in a word 
	 * move. Since the count was decremented by 16, add 12 to test if 
	 * there are any full word moves left to do.
	 */

$bzero_word
        addib,<,n 12,arg1,$bzero_cleanup

$bzero_loop_4
        addib,>= -4,arg1,$bzero_loop_4
        stbys,b,m r0,4(arg0)

	/*
	 * zero the last bytes that may be unaligned on a word boundary
	 */

$bzero_cleanup
        addib,=,n 4,arg1,$bzero_exit
        add	arg0,arg1,arg0
        bv      0(r2)
        stbys,e r0,0(arg0)


	/*
	 * zero by bytes
	 */

$bzero_bytes
        addib,> -1,arg1,$bzero_bytes
        stbs,ma r0,1(arg0) 

$bzero_exit
	bv,n	0(r2)

/*
 * void *
 * memset(void *dst, int ch, int count)
 *
 * XXX hack memset entry:
 *	just branch to bzero if set to 0, simple byte copy look OW
 *
 * Note that we count on branching backward to bzero, functionally because of
 * the delay slot of the compare and for efficiency due to branch prediction.
 */
	.export memset,entry
memset
	copy	arg0,ret0	/* memset returns original pointer */
	comb,=,n r0,arg1,bzero
	copy	arg2,arg1	/* nullified on failed branch to bzero */

$memset_bytes
        addib,> -1,arg2,$memset_bytes
        stbs,ma arg1,1(arg0) 
	bv,n	0(r2)

	.exit
	.procend


/*
 * int
 * copyin(src, dst, count)
 *	vm_offset_t	src;
 *	vm_offset_t	dst;
 *	int		count;
 */

	.export	copyin,entry
	.export	copyinmsg,entry
	.proc
	.callinfo 
copyin
copyinmsg

	.entry
	/*
	 * If zero bytes requested then exit success
	 */

        comb,=  r0,arg2,$copyin_exit
	ldi	0,ret0

	/*
	 * if negative number of bytes requested then error
	 */

        comb,>,n  r0,arg2,$copyin_error

	/*
	 * get the current thread pointer...
	 */

        ldil    L%cur_pcb,t1
        ldw     R%cur_pcb(t1),t1
	ldw	PCB_ACT(t1),t1
	ldw	ACT_THREAD(t1),r29
	ldw	ACT_USER_ACT(t1),t1

	/*
	 * get the task pointer and finally the map pointer...
	 *
	 * Set up thread recovery (interleaved to reduce stalls) in
	 * case we touch some bad user memory.
	 */

	ldil	L%$copyin_error,t2
	ldo	R%$copyin_error(t2),t2
	stw	t2,THREAD_RECOVER(r29)

	/*
	 * Then get the pmap pointer and finally get the space and pid
	 *
	 * Use "or"s from alignment check to reduce load/use stalls.
	 */

        or	arg0,arg1,t2
	ldw	ACT_SPACE(t1),t3
        or	t2,arg2,t2
	ldw	ACT_PID(t1),t4

	/*
	 * set up the space register sr1 to point to user space
	 */

	mtsp	t3,sr1
	mtctl	t4,pidr1

	/*
	 * See if the source and destination are word aligned and if the count
	 * is an integer number of words. If so then we can use an optimized 
	 * routine. If not then branch to bcopy_checkalign and see what we can
	 * do there.
	 */

        extru,= t2,31,2,r0
        b,n     $copyin_checkalign

        addib,<,n -16,arg2,$copyin_movewords

	/*
	 * We can move the data in 4 word moves. We'll use 4 registers to
	 * avoid interlock and pipeline stalls.
	 */

$copyin_loop16

        ldwm	16(sr1,arg0),t1
        ldw	-12(sr1,arg0),t2
        ldw     -8(sr1,arg0),t3
        ldw     -4(sr1,arg0),t4
        stwm    t1,16(arg1)
        stw     t2,-12(arg1)
        stw     t3,-8(arg1)
        addib,>= -16,arg2,$copyin_loop16
        stw     t4,-4(arg1)


	/*
	 * We have already decremented the count by 16, add 12 to it and then 
	 * we can test if there is at least 1 word left to move.
	 */

$copyin_movewords
        addib,<,n 12,arg2,$copyin_done

	/*
	 * Clean up any remaining words that were not moved in the 16 byte
	 * moves
	 */

$copyin_loop4
        ldwm	4(sr1,arg0),t1
        addib,>= -4,arg2,$copyin_loop4
        stwm    t1,4(arg1)

	copy	r0,ret0
	bv	0(r2)
	stw	r0,THREAD_RECOVER(r29)


$copyin_checkalign

	/*
	 * The source or destination is not word aligned or the count is not 
	 * an integral number of words. If we are dealing with less than 16 
	 * bytes then just do it byte by byte. Otherwise, see if the data has 
	 * the same basic alignment. We will add in the byte offset to size to
	 * keep track of what we have to move even though the stbys instruction
	 * won't physically move it. 
	 */

        comib,>= 15,arg2,$copyin_byte
        extru   arg0,31,2,t1
        extru   arg1,31,2,t2
        add     arg2,t2,arg2
        comb,<> t2,t1,$copyin_unaligned
        dep     0,31,2,arg0

	/*
	 * the source and destination have the same basic alignment. We will 
	 * move the data in blocks of 16 bytes as long as we can and then 
	 * we'll go to the 4 byte moves.
	 */

        addib,<,n -16,arg2,$copyin_aligned2

$copyin_loop_aligned4
        ldwm	16(sr1,arg0),t1
        ldw     -12(sr1,arg0),t2
        ldw     -8(sr1,arg0),t3
        ldw     -4(sr1,arg0),t4
        stbys,b,m t1,4(arg1)
        stwm    t2,4(arg1)
        stwm    t3,4(arg1)
        addib,>= -16,arg2,$copyin_loop_aligned4
        stwm    t4,4(arg1)

	/*
	 * see if there is anything left that needs to be moved in a word move.
	 * Since the count was decremented by 16, add 12 to test if there are 
	 * any full word moves left to do.
	 */

$copyin_aligned2
        addib,<,n 12,arg2,$copyin_cleanup

$copyin_loop_aligned2
        ldws,ma	4(sr1,arg0),t1
        addib,>= -4,arg2,$copyin_loop_aligned2
        stbys,b,m t1,4(arg1)

	/*
	 * move the last bytes that may be unaligned on a word boundary
	 */

$copyin_cleanup
         addib,=,n 4,arg2,$copyin_done
         ldws	0(sr1,arg0),t1
         add    arg1,arg2,arg1
         stbys,e t1,0(arg1)
	 copy	r0,ret0
	 bv	0(r2)
	 stw	r0,THREAD_RECOVER(r29)

	/*
	 * The source and destination are not alligned on the same boundary 
	 * types. We will have to shift the data around. Figure out the shift 
	 * amount and load it into cr11.
	 */

$copyin_unaligned
        sub,>=	t2,t1,t3
        ldwm    4(sr1,arg0),t1
        zdep    t3,28,29,t4
        mtctl   t4,11

	/*
	 * see if we can do some of this work in blocks of 16 bytes
	 */

        addib,<,n -16,arg2,$copyin_unaligned_words

$copyin_unaligned4
        ldwm	16(sr1,arg0),t2
	ldw	-12(sr1,arg0),t3
	ldw	-8(sr1,arg0),t4
	ldw	-4(sr1,arg0),r1
        vshd	t1,t2,r28
        stbys,b,m r28,4(arg1)
        vshd	t2,t3,r28
        stwm	r28,4(arg1)
        vshd	t3,t4,r28
        stwm	r28,4(arg1)
        vshd	t4,r1,r28
        stwm   	r28,4(arg1)
        addib,>= -16,arg2,$copyin_unaligned4
	copy	r1,t1

	/*
	 * see if there is a full word that we can transfer
	 */

$copyin_unaligned_words
        addib,<,n 12,arg2,$copyin_unaligned_cleanup1

$copyin_unaligned_loop
        ldwm	4(sr1,arg0),t2
        vshd    t1,t2,t3
        addib,< -4,arg2,$copyin_unaligned_cleanup2
        stbys,b,m t3,4(arg1)

        ldwm	4(sr1,arg0),t1
        vshd    t2,t1,t3
        addib,>= -4,arg2,$copyin_unaligned_loop
        stbys,b,m t3,4(arg1)

$copyin_unaligned_cleanup1
	copy	t1,t2

$copyin_unaligned_cleanup2
	addib,<=,n 4,arg2,$copyin_done
        add	arg1,arg2,arg1
	mfctl	sar,t3
	extru	t3,28,2,t3
	sub,<=	arg2,t3,r0
        ldwm    4(sr1,arg0),t1
        vshd    t2,t1,t3
        stbys,e t3,0(arg1)
	copy	r0,ret0
	bv	0(r2)
	stw	r0,THREAD_RECOVER(r29)

	/*
	 * move data one byte at a time
	 */

$copyin_byte
        comb,>=,n r0,arg2,$copyin_done

$copyin_loop_byte
        ldbs,ma	1(sr1,arg0),t1
        addib,> -1,arg2,$copyin_loop_byte
        stbs,ma t1,1(arg1) 


$copyin_done

	copy	r0,ret0
	bv   	0(r2)
	stw	r0,THREAD_RECOVER(r29)


$copyin_error

	ldi	1,ret0


$copyin_exit
	bv	0(r2)
	stw	r0,THREAD_RECOVER(r29)
	.exit
	.procend


/*
 * void 
 * copyout(src, dst, count)
 *	vm_offset_t	src;
 *	vm_offset_t	dst;
 *	int		count;
 */

	.export	copyout,entry
	.export	copyoutmsg,entry
	.proc
	.callinfo 
copyout
copyoutmsg

	.entry
	/*
	 * If zero bytes requested then exit success
	 */

        comb,=  r0,arg2,$copyout_exit
	copy	r0,ret0

	/*
	 * if negative number of bytes requested then error
	 */

        comb,>,n  r0,arg2,$copyout_error

	/*
	 * get the current thread pointer...
	 */

        ldil    L%cur_pcb,t1
        ldw     R%cur_pcb(t1),t1
	ldw	PCB_ACT(t1),t1
	ldw	ACT_THREAD(t1),r29
	ldw	ACT_USER_ACT(t1),t1

	/*
	 * get the task pointer and finally the map pointer...
	 *
	 * set up the thread recovery (interleaved to avoid stalls) in
	 * case we touch some bad user memory.
	 */

	ldil	L%$copyout_error,t2
	ldo	R%$copyout_error(t2),t2
	stw	t2,THREAD_RECOVER(r29)

	/*
	 * Then get the pmap pointer and finally get the space
	 *
	 * Use "or"s from alignment check to fill in load/use stall slots.
	 */

        or	arg0,arg1,t2
	ldw	ACT_SPACE(t1),t3
        or	t2,arg2,t2
	ldw	ACT_PID(t1),t4

	/*
	 * set up the space register sr1 to point to user space
	 */

	mtsp	t3,sr1
	mtctl	t4,pidr1

	/*
	 * See if the source and destination are word aligned and if the count
	 * is an integer number of words. If so then we can use an optimized 
	 * routine. If not then branch to bcopy_checkalign and see what we can
	 * do there.
	 */

        extru,= t2,31,2,r0
        b,n     $copyout_checkalign

        addib,<,n -16,arg2,$copyout_movewords

	/*
	 * We can move the data in 4 word moves. We'll use 4 registers to
	 * avoid interlock and pipeline stalls.
	 */

$copyout_loop16

        ldwm	16(arg0),t1
        ldw	-12(arg0),t2
        ldw     -8(arg0),t3
        ldw     -4(arg0),t4
        stwm    t1,16(sr1,arg1)
        stw     t2,-12(sr1,arg1)
        stw     t3,-8(sr1,arg1)
        addib,>= -16,arg2,$copyout_loop16
        stw     t4,-4(sr1,arg1)


	/*
	 * We have already decremented the count by 16, add 12 to it and then 
	 * we can test if there is at least 1 word left to move.
	 */

$copyout_movewords
        addib,<,n 12,arg2,$copyout_done

	/*
	 * Clean up any remaining words that were not moved in the 16 byte
	 * moves
	 */

$copyout_loop4
        ldwm	4(arg0),t1
        addib,>= -4,arg2,$copyout_loop4
        stwm    t1,4(sr1,arg1)

	copy	r0,ret0
	bv 	0(r2)
	stw	r0,THREAD_RECOVER(r29)


$copyout_checkalign

	/*
	 * The source or destination is not word aligned or the count is not 
	 * an integral number of words. If we are dealing with less than 16 
	 * bytes then just do it byte by byte. Otherwise, see if the data has 
	 * the same basic alignment. We will add in the byte offset to size to
	 * keep track of what we have to move even though the stbys instruction
	 * won't physically move it. 
	 */

        comib,>= 15,arg2,$copyout_byte
        extru   arg0,31,2,t1
        extru   arg1,31,2,t2
        add     arg2,t2,arg2
        comb,<> t2,t1,$copyout_unaligned
        dep     0,31,2,arg0

	/*
	 * the source and destination have the same basic alignment. We will 
	 * move the data in blocks of 16 bytes as long as we can and then 
	 * we'll go to the 4 byte moves.
	 */

        addib,<,n -16,arg2,$copyout_aligned2

$copyout_loop_aligned4
        ldwm	16(arg0),t1
        ldw     -12(arg0),t2
        ldw     -8(arg0),t3
        ldw     -4(arg0),t4
        stbys,b,m t1,4(sr1,arg1)
        stwm    t2,4(sr1,arg1)
        stwm    t3,4(sr1,arg1)
        addib,>= -16,arg2,$copyout_loop_aligned4
        stwm    t4,4(sr1,arg1)

	/*
	 * see if there is anything left that needs to be moved in a word move.
	 * Since the count was decremented by 16, add 12 to test if there are 
	 * any full word moves left to do.
	 */

$copyout_aligned2
        addib,<,n 12,arg2,$copyout_cleanup

$copyout_loop_aligned2
        ldws,ma	4(arg0),t1
        addib,>= -4,arg2,$copyout_loop_aligned2
        stbys,b,m t1,4(sr1,arg1)

	/*
	 * move the last bytes that may be unaligned on a word boundary
	 */

$copyout_cleanup
         addib,=,n 4,arg2,$copyout_done
         ldws	0(arg0),t1
         add    arg1,arg2,arg1
         stbys,e t1,0(sr1,arg1)
	 copy	r0,ret0
	 bv 	0(r2)
	 stw	r0,THREAD_RECOVER(r29)

	/*
	 * The source and destination are not alligned on the same boundary 
	 * types. We will have to shift the data around. Figure out the shift 
	 * amount and load it into cr11.
	 */

$copyout_unaligned
        sub,>=	t2,t1,t3
        ldwm    4(arg0),t1
        zdep    t3,28,29,t4
        mtctl   t4,11

	/*
	 * see if we can do some of this work in blocks of 16 bytes
	 */

        addib,<,n -16,arg2,$copyout_unaligned_words

$copyout_unaligned4
        ldwm	16(arg0),t2
	ldw	-12(arg0),t3
	ldw	-8(arg0),t4
	ldw	-4(arg0),r1
        vshd	t1,t2,r28
        stbys,b,m r28,4(sr1,arg1)
        vshd	t2,t3,r28
        stwm	r28,4(sr1,arg1)
        vshd	t3,t4,r28
        stwm	r28,4(sr1,arg1)
        vshd	t4,r1,r28
        stwm   	r28,4(sr1,arg1)
        addib,>= -16,arg2,$copyout_unaligned4
	copy	r1,t1

	/*
	 * see if there is a full word that we can transfer
	 */

$copyout_unaligned_words
        addib,<,n 12,arg2,$copyout_unaligned_cleanup1

$copyout_unaligned_loop
        ldwm	4(arg0),t2
        vshd    t1,t2,t3
        addib,< -4,arg2,$copyout_unaligned_cleanup2
        stbys,b,m t3,4(sr1,arg1)

        ldwm	4(arg0),t1
        vshd    t2,t1,t3
        addib,>= -4,arg2,$copyout_unaligned_loop
        stbys,b,m t3,4(sr1,arg1)

$copyout_unaligned_cleanup1
	copy	t1,t2

$copyout_unaligned_cleanup2
	addib,<=,n 4,arg2,$copyout_done
        add	arg1,arg2,arg1
	mfctl	sar,t3
	extru	t3,28,2,t3
	sub,<=	arg2,t3,r0
        ldwm    4(arg0),t1
        vshd    t2,t1,t3
        stbys,e t3,0(sr1,arg1)
	copy	r0,ret0
	bv 	0(r2)
	stw	r0,THREAD_RECOVER(r29)

	/*
	 * move data one byte at a time
	 */

$copyout_byte
        comb,>=,n r0,arg2,$copyout_done

$copyout_loop_byte
        ldbs,ma	1(arg0),t1
        addib,> -1,arg2,$copyout_loop_byte
        stbs,ma t1,1(sr1,arg1) 


$copyout_done

	copy	r0,ret0
	bv	0(r2)
	stw	r0,THREAD_RECOVER(r29)


$copyout_error

	ldi	1,ret0


$copyout_exit
	bv	0(r2)
	stw	r0,THREAD_RECOVER(r29)
	.exit
	.procend


/* void
 * phys_page_copy(src, dst)
 * 	vm_offset_t	src;
 *	vm_offset_t	dst;
 *
 * This routine will copy a single page from physical address src to physical
 * address dst. 
 *
 * NB: All virtual addresses pointing to these pages should be flushed before
 * this call to avoid cache inconsistency.
 *
 * NB: This routine is optimized for 32 byte cache lines.
 * 
 */

	.export	phys_page_copy,entry
	.proc
	.callinfo 

phys_page_copy
	.entry
	ldi	-4,t2
	ldi	-CACHE_LINE_SIZE,t3
	ldi	PARISC_PGBYTES-CACHE_LINE_SIZE,t4

	/*
	 * turn off all interrupts while the cache is in an inconsistent state
	 */

	rsm	PSW_I,t1

	/*
	 * move 4 words from a physical address to physical address
	 */
#define BT1 r31
#define BT2 arg3
#define BT3 ret0
#define BT4 ret1
#define BT5 arg2

$phys_bcopy_loop
	ldwas,ma 4(arg0),BT1
	ldwas,ma 4(arg0),BT2
	ldwas,ma 4(arg0),BT3
	ldwas,ma 4(arg0),BT4
	ldwas,ma 4(arg0),BT5
	stwas,ma BT1,4(arg1)
	stwas,ma BT2,4(arg1)
	stwas,ma BT3,4(arg1)
	stwas,ma BT4,4(arg1)
	stwas,ma BT5,4(arg1)
	ldwas,ma 4(arg0),BT1
	ldwas,ma 4(arg0),BT2
	ldwas,ma 4(arg0),BT3
	stwas,ma BT1,4(arg1)
	stwas,ma BT2,4(arg1)
	stwas,ma BT3,4(arg1)

	/*
	 * Since the source and destination are physical addresses, flush
	 * them back to memory. Turn off data translation to do this.
	 */
	rsm	PSW_D,r0
	pdc	t2(arg0)
	fdc	t2(arg1)
	addb,>= t3,t4,$phys_bcopy_loop
	ssm	PSW_D,r0

#undef BT1
#undef BT2
#undef BT3
#undef BT4
#undef BT5

	sync
	bv	0(r2)
	mtsm	t1
	.exit
	.procend

/* void
 * phys_bzero(dst, bytecount)
 *	vm_offset_t	dst;
 *	int		bytecount
 *
 * This routine will zero bytecount bytes at physical address dst.
 *
 * NB: All virtual addresses pointing to the page should be flushed before
 * this call to avoid cache inconsistency. 
 * 
 * This routine assumes that dst is page aligned and that bytecount is 
 * divisible by 4.
 */

	.export	phys_bzero,entry
	.proc
	.callinfo 

phys_bzero
	.entry
        comb,>=,n r0,arg1,$phys_bzero_exit

	ldil	L%dcache_line_mask,t1
	ldw	R%dcache_line_mask(t1),t3
	ldi	-4,t2

$phys_bzero_loop1

	/*
	 * turn off all interrupts while the cache is in an inconsistent state
	 */

	rsm	PSW_I,t1

	/*
	 * clear a word with a physical address
	 */

$phys_bzero_loop2
	addib,<= -4,arg1,$phys_bzero_finish
	stwas,ma r0,4(arg0)

	/*
	 * check if the cache lines needs to be flushed
	 */

$phys_bzero_continue
	and,=	arg0,t3,r0
	b,n	$phys_bzero_loop2

	/*
	 * need to flush the cache, turn off data translation so that we can 
	 * flush a physical address from the cache. We want to flush out this 
	 * physical addressed cache line so that it can't bite us later. This
	 * way only virtual addresses will be in the cache. Also restore 
	 * interrupts momentarily since the cache is (for a second) consistent.
	 */

	rsm	PSW_D,r0
	fdc	t2(arg0)
	b	$phys_bzero_loop1
	mtsm	t1

	/*
	 * flush the last physical addresses from the cache
	 */

$phys_bzero_finish
	rsm	PSW_D,r0
	fdc	t2(arg0)
	mtsm	t1

	sync

$phys_bzero_exit

	bv,n	0(r2)
	.exit
	.procend

/* void
 * lpage_zero(tlbpage, space, va)
 *	int		tlbpage;
 *	vm_offset_t	va;
 *	space_t		space;
 *
 * This routine will zero a *single* page using a virtual address. 
 *
 * NB: This routine is optimized for 32 byte cache lines.
 */
	.export	lpage_zero,entry
	.proc
	.callinfo

lpage_zero
	.entry
	mtsp	arg1,sr1

	/*
	 * Create a TLB mapping that allows the kernel to access the
	 * virtual address. Mark it dirty to avoid the dirty trap.
	 */
	ldil	L%TLB_AR_KRW,arg3
	depi	1,TLB_DIRTY_POS,1,arg3

	/*
	 * Turn off all interrupts to prevent someone else from trying to
	 * touch the page in question.
	 */
	rsm	PSW_I,t1

	/*
	 * Enter the TLB mapping.
	 */
	idtlba  arg0,(sr1,arg2)
	idtlbp  arg3,(sr1,arg2)

	/*
	 * Now zero the page.
	 */
	ldi	PARISC_PGBYTES-CACHE_LINE_SIZE,arg3
	copy	arg2,arg0
	ldi	-CACHE_LINE_SIZE,t2

$lpage_zero_loop
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
	stws,ma	r0,4(sr1,arg0)
        addb,>= t2,arg3,$lpage_zero_loop
	stws,ma	r0,4(sr1,arg0)

	/*
	 * Purge the data TLB now that we are finished with it, and turn
	 * interrupts back on.
	 */
	pdtlb	(sr1,arg2)
	bv	0(r2)
	mtsm	t1
	.exit
	.procend


/* void
 * lpage_copy(s_tlbpage, s_space, s_offset, dst)
 *	int		s_tlbpage;
 *	space_t		s_space;
 *	vm_offset_t	s_offset;
 *	vm_offset_t	dst;
 *
 * This routine will copy a virtual page to a physical page.
 *
 * WARNING: This routine is optimized for 32 byte cache lines. It will not
 * work on 16 byte lines, and will be non-optimal on 64 byte lines. There
 * is a check in the startup code that prints a warning for these cases.
 *
 */

	.export	lpage_copy,entry
	.proc
	.callinfo 

lpage_copy
	.entry
	ldi	-4,t2
	ldi	-CACHE_LINE_SIZE,t3
	mtsp	arg1,sr1

	/*
	 * Create a TLB mapping that allows the kernel to access the
	 * virtual address. Mark it dirty to avoid the dirty trap.
	 */
	ldil	L%TLB_AR_KRW,t4
	depi	1,TLB_DIRTY_POS,1,t4

	/*
	 * turn off all interrupts so no one can bother us.
	 */
	rsm	PSW_I,t1

	/*
	 * Enter the TLB mapping (purging any existing mapping first).
	 */
	pdtlb	(sr1,arg2)
	idtlba  arg0,(sr1,arg2)
	idtlbp  t4,(sr1,arg2)

	copy	arg2,arg0
	ldi	PARISC_PGBYTES-CACHE_LINE_SIZE,arg1

#define BT1 r31
#define BT2 r1
#define BT3 ret0
#define BT4 ret1
#define BT5 t4
	/*
	 * move 32 bytes from a virtual address to physical address in each
	 * loop iteration. 
	 */
$lpage_copy_loop
	ldwm	4(sr1,arg0),BT1
	ldwm	4(sr1,arg0),BT2
	ldwm	4(sr1,arg0),BT3
	ldwm	4(sr1,arg0),BT4
	ldwm	4(sr1,arg0),BT5
	stwas,ma BT1,4(arg3)
	stwas,ma BT2,4(arg3)
	stwas,ma BT3,4(arg3)
	stwas,ma BT4,4(arg3)
	stwas,ma BT5,4(arg3)
	ldwm	4(sr1,arg0),BT1
	ldwm	4(sr1,arg0),BT2
	ldwm	4(sr1,arg0),BT3
	stwas,ma BT1,4(arg3)
	stwas,ma BT2,4(arg3)
	stwas,ma BT3,4(arg3)

	/*
	 * Since the destination is physical, flush it back to memory. Turn
	 * off data translation to do this.
	 */
	rsm	PSW_D,r0
	fdc	t2(arg3)
	addb,>=  t3,arg1,$lpage_copy_loop
	ssm	PSW_D,r0

#undef BT1
#undef BT2
#undef BT3
#undef BT4
#undef BT5
	/*
	 * Purge the data TLB now that we are finished with it, and turn
	 * interrupts back on.
	 */
	pdtlb	(sr1,arg2)
	mtsm	t1
	bv	0(r2)
	sync
	.exit
	.procend
