/*
 *  (c) Copyright 1987 HEWLETT-PACKARD COMPANY
 *
 *  To anyone who acknowledges that this file is provided "AS IS"
 *  without any express or implied warranty:
 *      permission to use, copy, modify, and distribute this file
 *  for any purpose is hereby granted without fee, provided that
 *  the above copyright notice and this notice appears in all
 *  copies, and that the name of Hewlett-Packard Company not be
 *  used in advertising or publicity pertaining to distribution
 *  of the software without specific, written prior permission.
 *  Hewlett-Packard Company makes no representations about the
 *  suitability of this software for any purpose.
 */

/* UNISRC_ID	@(#)37.2   87/02/19  */
/* HPUX_ID: @(#)spacehdr.h	37.2     85/10/25 */

/******************************************************************************
*       the space dictionary consists of a sequence of space records          *
*******************************************************************************/

struct space_dictionary_record {
        union name_pt name;                 /* index to subspace name         */
        unsigned int  is_loadable: 1;       /* space is loadable              */
        unsigned int  is_defined : 1;       /* space is defined within file   */
        unsigned int  is_private : 1;       /* space is not sharable 	      */
        unsigned int  reserved   : 13;      /* reserved for future expansion  */
	unsigned int  sort_key   : 8;       /* sort key for space             */
        unsigned int  reserved2  : 8;       /* reserved for future expansion  */
        int           space_number;         /* space index                    */
        int           subspace_index;       /* index into subspace dictionary */
        unsigned int  subspace_quantity;    /* number of subspaces in space   */
        int           loader_fix_index;     /* index into loader fixup array  */
        unsigned int  loader_fix_quantity;  /* number of loader fixups in 
					       this space                     */
        int           init_pointer_index;   /* index into data(initialization)
                                               pointer array                  */
        unsigned int  init_pointer_quantity;/* number of data (init) pointers */
};

#define SPAHDR	struct space_dictionary_record
#define SPAHSZ	sizeof(SPAHDR)
