/* 
 * Copyright (c) 1990,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: csw.h 1.4 94/12/14$
 *	Author: Bob Wheeler, University of Utah CSL
 */

#ifndef ASSEMBLER
/*
 * Structure to build context area for C-threads package.
 */
struct csw {
	unsigned r2;
	unsigned r3;
	unsigned r4;
	unsigned r5;
	unsigned r6;
	unsigned r7;
	unsigned r8;
	unsigned r9;
	unsigned r10;
	unsigned r11;
	unsigned r12;
	unsigned r13;
	unsigned r14;
	unsigned r15;
	unsigned r16;
	unsigned r17;
	unsigned r18;
	unsigned r26;
	unsigned sr3;
	unsigned cr11;
	double fr0;
	double fr1;
	double fr2;
	double fr3;
	double fr12;
	double fr13;
	double fr14;
	double fr15;
};
#else
/*
 * Offsets for assembler programs
 */
#define	CSW_R2		0x0
#define	CSW_R3		0x4
#define	CSW_R4		0x8
#define	CSW_R5		0xc
#define	CSW_R6		0x10
#define	CSW_R7		0x14
#define	CSW_R8		0x18
#define	CSW_R9		0x1c
#define	CSW_R10		0x20
#define	CSW_R11		0x24
#define	CSW_R12		0x28
#define	CSW_R13		0x2c
#define	CSW_R14		0x30
#define	CSW_R15		0x34
#define	CSW_R16		0x38
#define	CSW_R17		0x3c
#define	CSW_R18		0x40
#define	CSW_R26		0x44
#define	CSW_SR3		0x48
#define	CSW_CR11	0x4c
#define	CSW_FR0		0x50
#define	CSW_FR1		0x58
#define	CSW_FR2		0x60
#define	CSW_FR3		0x68
#define	CSW_FR12	0x70
#define	CSW_FR13	0x78
#define	CSW_FR14	0x80
#define	CSW_FR15	0x88

#define	CSW_SIZE	144
#endif
