/* 
 * Copyright (c) 1990,1991,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: lock.s 1.11 94/12/14$
 *	Author: Bob Wheeler, University of Utah CSL
 */

#include <mach/machine/asm.h>

	.space	$TEXT$
	.subspa $CODE$

/*
 * int
 * spin_try_lock(s)
 * 	spin_lock_t *s;
 * 
 * Try to acquire a lock, return 1 if successful, 0 if not.
 */


	.export	spin_try_lock,entry
	.proc
	.callinfo frame=0

spin_try_lock

	.entry
	/*
	 * align the lock to a 16 byte boundary
	 */
	ldo	15(arg0),arg0
	depi	0,31,4,arg0

	/*
	 * attempt to get the lock
	 */
	ldcws	0(arg0),ret0

	/*
	 * if ret0 is 0 then we didn't get the lock and we return 0,
	 * else we own the lock and we return 1.
	 */
	subi,=	0,ret0,r0
	ldi	1,ret0

	bv,n	0(rp)
	.exit
	.procend


/*
 * void
 * spin_unlock(s)
 *	spin_lock_t *s;
 *
 * Release a lock.
 */
	.export	spin_unlock,entry
	.proc
	.callinfo frame=0

spin_unlock

	.entry
	/*
	 * align the lock to a 16 byte boundary
	 */
	ldo	15(arg0),arg0
	depi	0,31,4,arg0

	/*
	 * clear the lock by setting it non-zero
	 */
	ldi	-1,t1

	bv	0(rp)
	stw	t1,0(arg0)
	.exit
	.procend


/*
 * int
 * get_space()
 * 
 * Get the current space we are running in.
 */

	.export	get_space,entry
	.proc
	.callinfo frame=0

get_space

	.entry
	bv	0(rp)
	mfsp	sr4,ret0
	.exit
	.procend

/*
 * int
 * cthread_sp()
 * 
 * Return the current SP value.
 */

	.export	cthread_sp,entry
	.proc
	.callinfo frame=0

cthread_sp

	.entry
	bv	0(rp)
	copy	sp,ret0
	.exit
	.procend

