
#include "mutex.h"
#include "sched_prim.h"

/* Enter with interlock taken and locked==1,
   leave with interlock unlocked.  */
int
mutex_lock_solid(mutex_t m)
{
	int rc;

	assert(m->locked);
	m->waiters++;

	while (m->locked)
	{
		simple_unlock(m->interlock);
		if (rc = thread_wait_simple((int)m, 1, simple_lock_addr(m->interlock)))
			return rc;
		simple_lock(m->interlock);
	}

	m->waiters--;
	simple_unlock(m->interlock);
}

/* Enter and leave with interlock held.  */
void
mutex_unlock_notify(mutex_t m)
{
	assert(m->locked == 0);
	assert(m->waiters > 0);

	thread_wakeup((int)m);
}

